import { Attributes as GAttributes } from 'graphology-types';
import { XYPosition } from 'reactflow';
import { MultiGraph } from 'graphology';
import './utils';
import { SchemaAttribute } from '@graphpolaris/shared/lib/schema';
import { GeneralDescription, InputNodeType } from '../logic/general';
import { AllLogicTypes } from '../logic';

// export interface Attributes extends EntityNode | RelationNode | AttributeNode | FunctionNode | ModifierNode  {
// }

export interface NodeAttribute extends SchemaAttribute {
  handleId: string;
  // nodeCount: number;
  // summedNullAmount: number;
  // connectedRatio: number;
  // handles: string[];
}

export type NodeDefaults = {
  id?: string;
  type: string;
  width?: number;
  height?: number;
  attributes?: NodeAttribute[];
};

/** Interface for the data in an entity node. */
export interface EntityData {
  name: string;
  leftRelationHandleId?: string;
  rightRelationHandleId?: string;
}

/** Interface for the data in an relation node. */
export interface RelationData {
  name: string;
  collection: string;
  depth: { min: number; max: number };
  leftEntityHandleId?: string;
  rightEntityHandleId?: string;
}

export interface LogicData {
  name: string;
  // inputType: InputNodeType;
  // logicType: AllLogicTypes;
  // key: string;
  logic: GeneralDescription<AllLogicTypes>;
}

export type EntityNodeAttributes = XYPosition & EntityData & NodeDefaults;
export type RelationNodeAttributes = XYPosition & RelationData & NodeDefaults;
export type LogicNodeAttributes = XYPosition & LogicData & NodeDefaults;

export type QueryGraphNodes = EntityNodeAttributes | RelationNodeAttributes | LogicNodeAttributes;

// export class QueryGraph extends MultiGraph<QueryGraphNodes, GAttributes, GAttributes>; // is in utils.ts
