import { GeneralDescription, InputNodeType } from './general';
import { MathFilterTypes, MathFilters } from './mathFilters';
import { MathFunctionTypes, MathFunctions } from './mathFunctions';
import { StringFilterTypes, StringFilters } from './stringFilters';
import { StringFunctionTypes, StringFunctions } from './stringFunctions';

export type AllLogicTypes = MathFilterTypes | MathFunctionTypes | StringFilterTypes | StringFunctionTypes;
export type AllLogicDescriptions = GeneralDescription<AllLogicTypes>;

export const AllLogicMap: Record<string, AllLogicDescriptions> = {
  ...Object.assign({}, ...MathFilters.map((d) => ({ [d.key]: d }))),
  ...Object.assign({}, ...MathFunctions.map((d) => ({ [d.key]: d }))),
  ...Object.assign({}, ...StringFilters.map((d) => ({ [d.key]: d }))),
  ...Object.assign({}, ...StringFunctions.map((d) => ({ [d.key]: d }))),
};

export * from './graphFunctions';
export * from './mathFunctions';
export * from './mathFilters';
export * from './stringFunctions';
export * from './stringFilters';
