/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription, InputNode } from './general';

export enum MathFilterTypes {
  EQUAL = '==',
  NOT_EQUAL = '!=',
  GREATER_THAN = '>',
  LESS_THAN = '<',
  GREATER_THAN_EQUAL = '>=',
  LESS_THAN_EQUAL = '<=',
}

/** All available functions in the function bar. */
export const MathFilters: Array<GeneralDescription<MathFilterTypes>> = [
  {
    key: 'mathFilterEqual',
    name: 'Equal',
    type: MathFilterTypes.EQUAL,
    description: 'Equal to another value',
    numInputs: 2,
    inputs: [
      { name: '1', type: ['float'], position: Position.Left },
      { name: '2', type: ['float'], position: Position.Left },
    ],
  },
  {
    key: 'mathFilterNotEqual',
    name: 'Not Equal',
    type: MathFilterTypes.NOT_EQUAL,
    description: 'Not equal to another value',
    numInputs: 2,
    inputs: [
      { name: '1', type: ['float'], position: Position.Left },
      { name: '2', type: ['float'], position: Position.Left },
    ],
  },
];
