/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription } from './general';

export enum MathFunctionTypes {
  AVG = 'AVG',
  COUNT = 'COUNT',
  MAX = 'MAX',
  MIN = 'MIN',
  SUM = 'SUM',
  ROUND = 'ROUND',
  CEIL = 'CEIL',
  FLOOR = 'FLOOR',
  ADD = '+',
  SUBTRACT = '-',
  MULTIPLY = '*',
  DIVIDE = '/',
  MODULO = '%',
  CUSTOM = 'CUSTOM',
}

/** All available functions in the function bar. */
export const MathFunctions: Array<GeneralDescription<MathFunctionTypes>> = [
  {
    key: 'mathFunctionAvg',
    name: 'Average',
    type: MathFunctionTypes.AVG,
    description: 'Average of all values',
    numInputs: 1,
    inputs: [
      { name: '1', type: ['float'], position: Position.Left },
      { name: 'out', type: ['float'], position: Position.Right },
    ],
  },
  {
    key: 'mathFunctionCount',
    name: 'Count',
    type: MathFunctionTypes.COUNT,
    description: 'Count the number of values',
    numInputs: 1,
    inputs: [
      { name: '1', type: ['float'], position: Position.Left },
      { name: 'out', type: ['float'], position: Position.Right },
    ],
  },
];
