/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription } from './general';

export enum StringFilterTypes {
  EQUAL = '==',
  NOT_EQUAL = '!=',
  LIKE = 'LIKE',
  NOT_LIKE = 'NOT LIKE',
  IN = 'IN',
  NOT_IN = 'NOT IN',
}

/** All available functions in the function bar. */
export const StringFilters: Array<GeneralDescription<StringFilterTypes>> = [
  {
    key: 'stringFilterEqual',
    name: 'Equal',
    type: StringFilterTypes.EQUAL,
    description: 'Equal to another value',
    numInputs: 1,
    inputs: [
      { name: '1', type: ['string'], position: Position.Left },
      { name: '2', type: ['string'], position: Position.Left },
    ],
  },
];
