/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription } from './general';

export enum StringFunctionTypes {
  CONCAT = 'CONCAT',
  LOWER = 'LOWER',
  UPPER = 'UPPER',
  SUBSTRING = 'SUBSTRING',
  TRIM = 'TRIM',
}

/** All available functions in the function bar. */
export const StringFunctions: Array<GeneralDescription<StringFunctionTypes>> = [
  {
    key: 'stringFunctionConcat',
    name: 'Lower',
    type: StringFunctionTypes.LOWER,
    description: 'Lowercase all characters',
    numInputs: 1,
    inputs: [
      { name: '1', type: ['string'], position: Position.Left },
      { name: 'lower_case', type: ['string'], position: Position.Right },
    ],
  },
];
